import { world, system } from "@minecraft/server";

function durabilityOnChanged(item, player, isHitEntity = false) {
    let level = item.getComponent("minecraft:enchantable")?.getEnchantment("unbreaking")?.level;

    function durability() {
        let durability = item.getComponent("minecraft:durability");

        const t = Math.floor(Math.random() * 100);

        if (t < durability.getDamageChance()) {
            if (!isHitEntity) durability.damage += 1;
            if (durability.damage >= durability.maxDurability) {
                player.playSound("random.break");
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', undefined)
            } else {
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item)
            }
        } else {
            if (!isHitEntity) return;
            durability.damage -= 1;
            if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item);
        }
    }

    const t = Math.floor(Math.random() * 10)
    if (level === 1 && t > 8) return;
    else if (level === 2 && t > 6) return;
    else if (level === 3 && t > 4) return;
    else durability();
}

world.beforeEvents.worldInitialize.subscribe(initEvent => { initEvent.itemComponentRegistry.registerCustomComponent('pa_breadstick:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_axe_head:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_reverance:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_shulker_core:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_endfire_sword:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_ultramarine_apple:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:haste", 1800, {amplifier: 3});
e.source.addEffect("minecraft:health_boost", 1200, {amplifier: 15});
e.source.addEffect("minecraft:jump_boost", 600, {amplifier: 5});
e.source.addEffect("minecraft:regeneration", 1200, {amplifier: 5});
e.source.addEffect("minecraft:resistance", 1800, {amplifier: 3});
e.source.addEffect("minecraft:saturation", 200, {amplifier: 1});
e.source.addEffect("minecraft:speed", 1800, {amplifier: 3});
e.source.addEffect("minecraft:strength", 300, {amplifier: 3});
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_pure_cherries:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:regeneration", 240, {amplifier: 2});
e.source.addEffect("minecraft:speed", 800, {amplifier: 2});
e.source.removeEffect("minecraft:blindness");
e.source.removeEffect("minecraft:fatal_poison");
e.source.removeEffect("minecraft:slowness");
e.source.removeEffect("minecraft:poison");
e.source.removeEffect("minecraft:nausea");
e.source.removeEffect("minecraft:mining_fatigue");
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_cherries:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:poison", 600, {amplifier: 1});
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_warden_core:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_transparentremains:trigger', {
  onUse: e => { e.source.runCommand("function cooldown");
e.source.runCommand("function spee"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_prismatic_pearl:trigger', {
  onUse: e => { e.source.runCommand("function PrisOewrl"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_sotn:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function doonnn2");
e.source.runCommand("function spee");
e.source.runCommand("function resistsja"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); e.attackingEntity.runCommand("function enchsnterrr"); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_resonant_sword:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function woeowoeow");
e.source.runCommand("function finalfunviom"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_thunderous_axe:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function thunderboomiethingy"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); e.attackingEntity.runCommand("function slowwww"); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_cherry_axe:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function cherylregenenene");
e.source.runCommand("function spee"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); e.attackingEntity.runCommand("function Cheryl"); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_midnight_clock:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function darkiewarky");
e.source.runCommand("function sleepytime"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_sword_of_sculk:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function stopmovinglol");
e.source.runCommand("function bigboooom");
e.source.runCommand("function darkiewarky");
e.source.runCommand("function restitisiaie");
e.source.runCommand("function nomininglood");
e.source.runCommand("function Hungary"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_floral_sword:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function regen");
e.source.runCommand("function poisonIvy"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); e.attackingEntity.runCommand("function mendingg");
e.attackingEntity.runCommand("function fireea"); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_nuetra:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function nomininglood");
e.source.runCommand("function mendingg");
e.source.runCommand("function icannevergetabreakkkkkkkkkk"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_withering_sword:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function nomininglood");
e.source.runCommand("function sugi");
e.source.runCommand("function witherthem"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); e.attackingEntity.runCommand("function smiler"); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_floral_cookie:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:jump_boost", 200, {amplifier: 1});
e.source.addEffect("minecraft:speed", 240, {amplifier: 5});
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_everyend:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function sugi");
e.source.runCommand("function soawnpoint");
e.source.runCommand("function sayyy"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); e.attackingEntity.runCommand("function looting74");
e.attackingEntity.runCommand("function fireea"); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_axe_axe:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_daytime_clock:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function wakeytime");
e.source.runCommand("function heal"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});
 });
